package com.example.ecgsmartapp;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.chart.PointStyle;
import org.achartengine.model.SeriesSelection;
import org.achartengine.model.XYMultipleSeriesDataset;
import org.achartengine.model.XYSeries;
import org.achartengine.renderer.XYMultipleSeriesRenderer;
import org.achartengine.renderer.XYSeriesRenderer;
import org.achartengine.tools.PanListener;
import org.achartengine.tools.ZoomEvent;
import org.achartengine.tools.ZoomListener;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Environment;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.PopupMenu;
import android.widget.TextView;
import android.widget.Toast;


public class Pag2 extends Activity {
	
	public String file_name;	
	public GraphicalView mChart;
    public XYMultipleSeriesDataset dataset=new XYMultipleSeriesDataset();
	public XYMultipleSeriesRenderer mRenderer=new XYMultipleSeriesRenderer();     
	public  XYSeries xSeries=new XYSeries("X Series");
	public  XYSeries point_12=new XYSeries("selection");
	public int numero_step_asse_x = 15;
	public Button get_1;
	public Button get_2;
	public Button clear1;
	public EditText edit_1; 
	public Double x_1, x_2, y_1, y_2;
	public int done_1, done_2;
	public Button button_filter2;
	public Button button_gain_plus, button_gain_minus;
	public TextView tx_gain;	
	public TextView tx_pt_12;
	
	public int low_pass_filter_id=40;
	public int high_pass_filter_id=0;
	public int wandering_id=1;
	public int notch_MA=0;
	public String plot_title_1="ECG - band: 0.1";
	public String plot_title_2="-40 Hz";
	public String plot_title_3=" - baseline removed";
	public String plot_title_0="";
	public String plot_title_50_60="";
	
	public int Fs=600;	
	public double gain_x=1;	
	public int lead;	
	public double [] vector;
	public double [] vector_low_high_pass_filtered;
		
	public String files_folder="ECG_Files";
	
	public double screenInches;
	public int size_LabelsTextSize;
	public int size_LineWidth;			 
	public int  size_AxisTitleTextSize;
	public int  size_ChartTitleTextSize;
	public int pixel_density;
	 
 	public double [] filter_hB1= new double[3]; 
	public double [] filter_hA1= new double[3];
	
	public double [] filter_hB2= new double[3]; 
	public double [] filter_hA2= new double[3];
	
	public double [] filter_lB1= new double[3]; 
	public double [] filter_lA1= new double[3];
	
	public double [] filter_lB2= new double[3]; 
	public double [] filter_lA2= new double[3];
		
	public double [] buffer_fhB1= {0,0,0};
	public double [] buffer_flB1= {0,0,0};
	public double [] buffer_fhA1= {0,0,0};
	public double [] buffer_flA1= {0,0,0};
	
	public double [] buffer_fhB2= {0,0,0};
	public double [] buffer_flB2= {0,0,0};
	public double [] buffer_fhA2= {0,0,0};
	public double [] buffer_flA2= {0,0,0};
	
	public double G1_high=1;
	public double G2_high=1;
	public double G1_low=1;
	public double G2_low=1;
	
	public double output_low1=0;
	public double output_low2=0;
	public double output_high1=0;
	public double output_high2=0;
	
	public double output1_50_60=0;
	public double output2_50_60=0;
	public double output3_50_60=0;
	public double output4_50_60=0;
	
	public int notch50or60=0;
	
	public double [] buffer_der1= {0,0,0,0,0};
	public double [] buffer_der2= {0,0,0,0,0};
	public double [] der= {-2,-1,0,1,2};
	public double output_der1=0;
	public double output_der2=0;
	public double [] buffer_wandering= new double[200];
	public double summ=0;
	public int ind_PQ;
	public double threshold=0;
	public double [] PQ;
	public int [] PQ_x;
	public int delta_interp_x;
	public double delta_interp_y;
	public double [] PQ_interp;
	public int n_PQ;

	public LinearLayout.LayoutParams layoutParams;
	public LinearLayout layout_graph;
	public double width, height;
	
	
	// filter coefficients
	
	// The filter is a "Direct Form II Second-Order-Section"
	// Order = 4
	// Sections = 2
	// Stable: Yes
	// Sampling Frequency = 600 Hz
	
	// "A" identifies the denominator and "B" identifies the numerator
	// "1" identifies the first section and "2" identifies the second section
	// "G" identifies the gain
	
	
	 // Notch Filters @ 50, 60, 100 and 120 Hz  for Fs = 600 Hz
	double [] num_filter_50= {1,-1.731688047696030,0.999790560489761};
   	double [] den_filter_50= {1,-1.695774820284193,0.958550747036629};
   	double G_filter_50=0.9801104055521309;
   				    	
   	double [] num_filter_100= {1,-0.999790560489760,0.999790560489761};
   	double [] den_filter_100= {1,-0.979056048976068,0.958550747036629};
   	double G_filter_100=0.9794899854086989; 
   	
   	double [] num_filter_60= {1,-1.617695108503741,0.999790560489761};
   	double [] den_filter_60= {1,-1.584145964134460,0.958550747036629};
   	double G_filter_60=0.9798734714962504;
   	
   	double [] num_filter_120= {1,-0.617904548013980,0.999790560489761};
   	double [] den_filter_120= {1,-0.605089915158392,0.958550747036629};
   	double G_filter_120=0.9794336030555506;
	
   		
	double [] buffer_num_filter_50= {0,0,0};
	double [] buffer_den_filter_50= {0,0,0};
	double [] buffer_num_filter_60= {0,0,0};
	double [] buffer_den_filter_60= {0,0,0};
	double [] buffer_num_filter_100= {0,0,0};
	double [] buffer_den_filter_100= {0,0,0};
	double [] buffer_num_filter_120= {0,0,0};
	double [] buffer_den_filter_120= {0,0,0};
	
	double [] buffer2_num_filter_50= {0,0,0};
	double [] buffer2_den_filter_50= {0,0,0};
	double [] buffer2_num_filter_60= {0,0,0};
	double [] buffer2_den_filter_60= {0,0,0};
	double [] buffer2_num_filter_100= {0,0,0};
	double [] buffer2_den_filter_100= {0,0,0};
	double [] buffer2_num_filter_120= {0,0,0};
	double [] buffer2_den_filter_120= {0,0,0}; 
		
	double [] buffer0_50= {0,0,0,0,0,0,0,0,0,0,0,0};
	double [] buffer0_60= {0,0,0,0,0,0,0,0,0,0};
	 
	 	 
	 
// LOW PASS FILTERS
 	
 	
 	// Low Pass , cut off frequency: 25 Hz
 	//denominators
 	double [] A1_low25= { 1, -1.757753609482727, 0.819760442927314};
 	double [] A2_low25= { 1, -1.559054301141692, 0.614051781937882};
 	// numerators
 	double [] B1_low25= {1,2,1};
 	double [] B2_low25= {1,2,1};
 	// Gains
 	double G1_low25=0.015501708361147;
 	double G2_low25=0.013749370199048;
 	

 	// Low Pass , cut off frequency: 35 Hz
 	//denominators
 	double [] A1_low35= { 1, -1.641977617376592, 0.758796104516994};
 	double [] A2_low35= { 1, -1.402731984362635, 0.502529342464571};
 	// numerators
 	double [] B1_low35= {1,2,1};
 	double [] B2_low35= {1,2,1};
 	// Gains
 	double G1_low35=0.029204621785100;
 	double G2_low35=0.024949339525484;
 	 	
 	
 	// Low Pass , cut off frequency: 40 Hz
 	//denominators
 	double [] A1_low40= { 1, -1.581005271466872, 0.730625726656938};
 	double [] A2_low40= { 1, -1.328044221785862, 0.453725384627135};    	
 	// numerators
 	double [] B1_low40= {1,2,1};
 	double [] B2_low40= {1,2,1};	    	
 	// Gains
 	double G1_low40=0.037405113797517;
 	double G2_low40=0.031420290710318;
 		
 	
 	// Low Pass , cut off frequency: 100 Hz
 	//denominators
 	double [] A1_low100= { 1, -0.751081421656940, 0.502162843313880};
 	double [] A2_low100= { 1, -0.555523722444109, 0.111047444888218};		    	
 	// numerators
 	double [] B1_low100= {1,2,1};
 	double [] B2_low100= {1,2,1};
 	// Gains
 	double G1_low100=0.187770355414235;
 	double G2_low100=0.138880930611027;
 	
 	
	// Low Pass , cut off frequency: 150 Hz
	//denominators
	double [] A1_low150= { 1, -0.160589618511030, 0.446462692171690};
	double [] A2_low150= { 1, -0.115415025303165, 0.039566129896580};		    	
	// numerators
	double [] B1_low150= {1,2,1};
	double [] B2_low150= {1,2,1};
	// Gains
	double G1_low150=0.361615673042922;
	double G2_low150=0.259891532474145;

 	
     
// HIGH PASS FILTERS	
 	
 	
 	// High Pass , cut off frequency: 0.1 Hz
 	//denominators		    	
 	double [] A1_high1010= { 1, -1.999197734721228, 0.999198830904549};
 	double [] A2_high1010= { 1, -1.998065806264844, 0.998066901827515};		    	
 	// numerators
 	double [] B1_high1010= {1,-2,1};
 	double [] B2_high1010= {1,-2,1};
 	// Gains
 	double G1_high1010=0.999599141406445;
 	double G2_high1010=0.999033177023090;
 	
 	
 	// High Pass , cut off frequency: 0.15 Hz
 	//denominators
 	double [] A1_high1015= { 1, -1.998796021366643, 0.998798487284930};
 	double [] A2_high1015= { 1, -1.997099290226235, 0.997101754051262};		    	
 	// numerators
 	double [] B1_high1015= {1,-2,1};
 	double [] B2_high1015= {1,-2,1};
 	// Gains
 	double G1_high1015=0.999398627162893;
 	double G2_high1015=0.998550261069374;
 	
 	 	
 	// High Pass , cut off frequency: 0.25 Hz
 	//denominators	    	
 	double [] A1_high1025= { 1, -1.997991434939058, 0.997998281967313};
 	double [] A2_high1025= { 1, -1.995167418322513, 0.995174255672988};		    	
 	// numerators
 	double [] B1_high1025= {1,-2,1};
 	double [] B2_high1025= {1,-2,1};
 	// Gains
 	double G1_high1025=0.998997429226593;
 	double G2_high1025=0.998550261069374;

 	
 	// High Pass , cut off frequency: 0.5 Hz
 	//denominators 	
 	double [] A1_high1050= { 1, -1.995973219799735, 0.996000580481828};
 	double [] A2_high1050= { 1, -1.990344492411856, 0.990371775935689};		    	
 	// numerators
 	double [] B1_high1050= {1,-2,1};
 	double [] B2_high1050= {1,-2,1};
 	// Gains
 	double G1_high1050=0.997993450070391;
 	double G2_high1050=0.995179067086886;
         
 	
 	// High Pass , cut off frequency: 1 Hz
 	//denominators		    	
 	double [] A1_high1100= { 1, -1.991908009819602, 0.992017233388420};
 	double [] A2_high1100= { 1, -1.980727460109226, 0.980836070607794};		    	
 	// numerators
 	double [] B1_high1100= {1,-2,1};
 	double [] B2_high1100= {1,-2,1};
 	// Gains
 	double G1_high1100=0.995981310802006;
 	double G2_high1100=0.990390882679255;
 	
 	 
 
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.pag2); 		
		done_1=0;
		done_2=0;
		
		Intent intent2=getIntent(); 			
		file_name =intent2.getStringExtra("scelta");
		 
		
		 edit_1 = (EditText)findViewById(R.id.edit_value1);
		 get_1 = (Button)findViewById(R.id.get_value1);
		 get_2 = (Button)findViewById(R.id.get_value2);
		 clear1 = (Button)findViewById(R.id.clear1);
		 button_filter2 = (Button)findViewById(R.id.button_filter2);
		 layout_graph = (LinearLayout) findViewById(R.id.graph2);
		 button_gain_plus = (Button)findViewById(R.id.gain_plus);
		 button_gain_minus = (Button)findViewById(R.id.gain_minus);
		 tx_gain = (TextView)findViewById(R.id.textGain);
		 tx_pt_12 = (TextView)findViewById(R.id.text_pt_12);
		 
		 plot_title_0=file_name+";  "; 
		 edit_1.setEnabled(false);
		 button_gain_plus.setEnabled(true);
		 button_gain_minus.setEnabled(true);
	 
		 File file_dir = Environment.getExternalStorageDirectory();
		 File file = new File(file_dir.getAbsolutePath() + "/" + files_folder,file_name);
				
		 try {
			 DisplayMetrics dm = new DisplayMetrics();
			 getWindowManager().getDefaultDisplay().getMetrics(dm);
			 width=dm.widthPixels;
			 height=dm.heightPixels;
			 pixel_density=dm.densityDpi;
			 double wi=(double)width/(double)pixel_density;
			 double hi=(double)height/(double)pixel_density;
			 double x = Math.pow(wi,2);
			 double y = Math.pow(hi,2);
			 screenInches = Math.sqrt(x+y);  // display dimension (diagonal) in inch 
		 }
	   
		 catch (Exception e) {
				 pixel_density=480;		 
		 }
		 
		
		 if (pixel_density>650)	
		 {
			 size_LabelsTextSize = 35;
			 size_LineWidth = 18;			 
			 size_AxisTitleTextSize = 40;
			 size_ChartTitleTextSize = 45;
		 }
		 else	 
				if (pixel_density<330)	
				{
					 size_LabelsTextSize = 13;
					 size_LineWidth = 5;			 
					 size_AxisTitleTextSize = 13;
					 size_ChartTitleTextSize = 15;
				}
				else
				{
					 size_LabelsTextSize = 25;
					 size_LineWidth = 10;			 
					 size_AxisTitleTextSize = 30;
					 size_ChartTitleTextSize = 35;
				}
			
			 
			 
		if (screenInches>6)		
		{
		   			 edit_1.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 tx_gain.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 tx_pt_12.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 button_gain_plus.setTextSize(TypedValue.COMPLEX_UNIT_SP,14);
					 button_gain_minus.setTextSize(TypedValue.COMPLEX_UNIT_SP,14);
					 button_filter2.setTextSize(TypedValue.COMPLEX_UNIT_SP,14);
					 clear1.setTextSize(TypedValue.COMPLEX_UNIT_SP,14);
					 get_1.setTextSize(TypedValue.COMPLEX_UNIT_SP,14);
					 get_2.setTextSize(TypedValue.COMPLEX_UNIT_SP,14);
		}
		else
				 if (screenInches<4)	 	
				 {
					 edit_1.setTextSize(TypedValue.COMPLEX_UNIT_SP,8);
					 tx_gain.setTextSize(TypedValue.COMPLEX_UNIT_SP,8);
					 tx_pt_12.setTextSize(TypedValue.COMPLEX_UNIT_SP,8);
					 button_gain_plus.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 button_gain_minus.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 button_filter2.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 clear1.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 get_1.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 get_2.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
				 }
				 else
				 {
					 edit_1.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 tx_gain.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 tx_pt_12.setTextSize(TypedValue.COMPLEX_UNIT_SP,10);
					 button_gain_plus.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 button_gain_minus.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 button_filter2.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 clear1.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 get_1.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
					 get_2.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
				 }
			 			 
			 
			  // read setting file
			    try { 
				    
				    	File file_for_settings = getFilesDir ();
						File f_Settings = new File(file_for_settings,"Settings.txt");
				    	InputStream inputStream = new FileInputStream(f_Settings);
				   	 	String read_settings;
				   	 
				        if ( inputStream != null ) {
				            InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
				            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
				            String receiveString = "";
				            StringBuilder builder_settings = new StringBuilder("");
	
				            while((read_settings = bufferedReader.readLine()) != null){
				            	builder_settings.append(read_settings);
				            }
				            
				            String settings_string = builder_settings.toString();
				            lead= Integer.parseInt(String.valueOf(settings_string.charAt(0)));
				        	int temp_notch50or60=Integer.parseInt(String.valueOf(settings_string.charAt(2)));
				        	if (temp_notch50or60==0)
				        			notch50or60=0;
				        	else
				        		if (temp_notch50or60==6)
				        			notch50or60=60;
				        		else
				        			notch50or60=50;
				        	
				        	
				        	 if (lead==1)
				        	 {
				        		 wandering_id=1;
				        		 plot_title_3=" - baseline removed";
				        	 }
					         else
					         {
					        	 wandering_id=0;
					        	 plot_title_3="";
					         }
					      
					      
				        	 if (notch50or60==50)
				        		 plot_title_50_60=" ~ 50 Hz";
				        	 else
				        		 if (notch50or60==60)
					        		 plot_title_50_60=" ~ 60 Hz";
					        	 else
					        		 if (notch50or60==0)
					        			 plot_title_50_60=" ~ none";
					      
				        	
				        	 bufferedReader.close();
	
				        	 inputStream.close();
				          
				        }
			    }
			    catch (Exception e) { }
			    		 
					
			 get_1.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) { 
						
						mRenderer.setZoomEnabled(false, false);
						get_1.setEnabled(false);
						get_2.setEnabled(false);
						mRenderer.setZoomButtonsVisible(false);				         
				        mRenderer.setPanEnabled(false);
				          
				        mChart.setOnClickListener(new View.OnClickListener() {
				                @Override
				                public void onClick(View v) {
				                  SeriesSelection seriesSelection = mChart.getCurrentSeriesAndPoint();
				                  point_12.clear();				                 	         				                 	         
				                  if (seriesSelection == null) {				                   
				                	  edit_1.setText("no point selected");
				                	  done_1=0;
				                  } 
				                  else
				                  {
				                	  x_1=seriesSelection.getXValue();
								      y_1=seriesSelection.getValue(); 
								      
				                	  if (done_2>0) 
				                	  { 
				                		  	edit_1.setText("dX=" + String.format("%.0f", (x_2-x_1)*1000/Fs) + " [ms], dY=" + String.format("%.1f", (y_2-y_1)) + " [mV]");
				                	  }				                	  
				                	  else edit_1.setText("");
				                	  		done_1=1;
				                					                   
				                  }
				                
				              	mRenderer.setZoomEnabled(true, true);
								get_1.setEnabled(true);
								get_2.setEnabled(true);
								mRenderer.setZoomButtonsVisible(true);
								mRenderer.setPanEnabled(true);					   
						         
						         if (done_1>0) 
						         {	point_12.add(x_1, y_1);
						        	point_12.add(x_1+1, y_1);						        	 
						         }
						         
						         if (done_2>0) 
						         {	point_12.add(x_2, y_2);
					        	  	point_12.add(x_2+1, y_2);						        	 
					        	 }
						         
						         mChart.repaint();
						         
				                }
				            	}); 				         
					}});	
			 
			 
			 get_2.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) { 
						
						mRenderer.setZoomEnabled(false, false);
						get_1.setEnabled(false);
						get_2.setEnabled(false);
						mRenderer.setZoomButtonsVisible(false);				         
				        mRenderer.setPanEnabled(false);
				        
				        mChart.setOnClickListener(new View.OnClickListener() {
				                @Override
				                public void onClick(View v) {
				                  SeriesSelection seriesSelection = mChart.getCurrentSeriesAndPoint();
				                  point_12.clear();
				                  
				                  if (seriesSelection == null) {				                   
				                	  edit_1.setText("no point selected");
				                	  done_2=0;
				                  } 
				                  else 
				                  {
				                	 x_2=seriesSelection.getXValue();
								     y_2=seriesSelection.getValue(); 
								     
				                	  if (done_1>0) 
				                	  {
				                		  edit_1.setText("dX=" + String.format("%.0f", (x_2-x_1)*1000/Fs) + " [ms], dY=" + String.format("%.1f", (y_2-y_1)) + " [mV]");				                	  
				                	  }
				                	  else 
				                		  edit_1.setText("");
				                	  
				                	  done_2=1;     	  
				                  }
				                  
				                mRenderer.setZoomEnabled(true, true);
								get_1.setEnabled(true);
								get_2.setEnabled(true);
								mRenderer.setZoomButtonsVisible(true);
								mRenderer.setPanEnabled(true);
			        
						         if (done_1>0) 
						         {	point_12.add(x_1, y_1);
					        	  	point_12.add(x_1+1, y_1);						        	 
					        	 }
						         
						         if (done_2>0) 
						         {	point_12.add(x_2, y_2);
					        	  	point_12.add(x_2+1, y_2);						        	 
					        	 }
						        
						         mChart.repaint();
						         
				                }
				           	}); 				         
					}});	
			 
		 
			 clear1.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) { 
					
						mRenderer.setZoomEnabled(true, true);
						get_1.setEnabled(true);
						get_2.setEnabled(true);
						mRenderer.setZoomButtonsVisible(true);				         
				        mRenderer.setPanEnabled(true);
				        point_12.clear();
				        done_1=0;
				        done_2=0;
				        mChart.repaint();
				        edit_1.setText("");
					}});	
			 
			 
			 
			 button_gain_plus.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) { 
					
						gain_x=gain_x+0.5;						
						tx_gain.setText("Gain: x "+String.valueOf(gain_x));
						
						if(gain_x==5)
							button_gain_plus.setEnabled(false);	
						
						button_gain_minus.setEnabled(true);
						xSeries.clear();				    	  				    	  
						  
						  for(int i=0;i<vector_low_high_pass_filtered.length;i+=2)
						  {						 		 	    		    
							 	if (wandering_id!=0)							 		
							 	 //  Adding data to the X Series.
						          xSeries.add(i,(vector_low_high_pass_filtered[i]-PQ_interp[i])*gain_x);
							 	else							        		
							 	 //  Adding data to the X Series.
						          xSeries.add(i,vector_low_high_pass_filtered[i]*gain_x);
						  }
						  									   
						  dataset.clear();						        	   
					      dataset.addSeries(0,xSeries);
					      point_12.clear();
					      edit_1.setText("");	
					      done_1=0;
					      done_2=0;
					      dataset.addSeries(1,point_12);
						  mChart.repaint();					   			
					}});	
			 
			 
			 
			 button_gain_minus.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) { 
					
						gain_x=gain_x-0.5;		
						tx_gain.setText("Gain: x "+String.valueOf(gain_x));
						
						if(gain_x==0.5)
							button_gain_minus.setEnabled(false);	
						
						button_gain_plus.setEnabled(true);
						xSeries.clear();				    	  
				    	  
						for(int i=0;i<vector_low_high_pass_filtered.length;i+=2)
						{		 	    		    
							 	if (wandering_id!=0)							 		
							 		//  Adding data to the X Series.
							 		xSeries.add(i,(vector_low_high_pass_filtered[i]-PQ_interp[i])*gain_x);
							 	else							        		
							 		//  Adding data to the X Series.
							 		xSeries.add(i,vector_low_high_pass_filtered[i]*gain_x);
						}
						  					   
					        	    dataset.clear();				        	   
					        	    dataset.addSeries(0,xSeries);				
					        	    point_12.clear();
					        	    edit_1.setText("");			
					        	    done_1=0;
							        done_2=0;
					        	    dataset.addSeries(1,point_12);
						        	mChart.repaint();					   			
					}});	
			 
			 
			 
			 button_filter2.setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View v) { 
					
						 PopupMenu popup = new PopupMenu(Pag2.this, button_filter2);  
						 //Inflating the Popup using xml file  
						 popup.getMenuInflater().inflate(R.menu.menu_filter_2, popup.getMenu());	

						 //registering popup with OnMenuItemClickListener  
						 popup.setOnMenuItemClickListener(new PopupMenu.OnMenuItemClickListener() {  
						  
						 public boolean onMenuItemClick(MenuItem item) { 
						 	
							 switch (item.getItemId()) {
							 							  
						        case R.id.filter1_2:						        	
						        	high_pass_filter_id=0;
						        	low_pass_filter_id=0;	
						        	wandering_id=0;
						        	notch50or60=0;	
						        	notch_MA=0;
						        	plot_title_1="ECG - band: 0.1"; 
						        	plot_title_2="-150 Hz";  
						        	plot_title_3="";
						        	plot_title_50_60="";
						        	break;
						        	
								case R.id.filter_base_line:						        								        	
							        wandering_id=1;
							        plot_title_3=" - baseline removed";							        						        	
							        break;
						            	
						        case R.id.filter2_2:
						        	high_pass_filter_id=1010;
						        	plot_title_1="ECG - band: 0.1";						        
						        	break;
						        	
						        case R.id.filter3_2:
						        	high_pass_filter_id=1015;
						        	plot_title_1="ECG - band: 0.15";						        	
						        	break;
						        	
						        case R.id.filter4_2:
						        	high_pass_filter_id=1025;
						        	plot_title_1="ECG - band: 0.25";						        	
						        	break;
						        	
						        case R.id.filter5_2:
						        	high_pass_filter_id=1050;
						        	plot_title_1="ECG - band: 0.5";						        	
						        	break;

						        case R.id.filter6_2:
						        	high_pass_filter_id=1100;
						        	plot_title_1="ECG - band: 1";						        	
						        	break;
						        	
						        case R.id.filter7_2:
						        	low_pass_filter_id=25;						        	
						        	plot_title_2="-25 Hz";
						        	break;
						        	
						        case R.id.filter8_2:
						        	low_pass_filter_id=35;
						        	if (notch_MA==0)
						        		plot_title_2="-35 Hz";						      
						        	break;

						        case R.id.filter9_2:
						        	low_pass_filter_id=40;
						        	if (notch_MA==0)
						        		plot_title_2="-40 Hz";
						        	break;

						        case R.id.filter10_2:
						        	low_pass_filter_id=100;
						        	if (notch_MA==0)
						        		plot_title_2="-100 Hz";
						        	break;		        	

						        case R.id.filter11_2:
						        	low_pass_filter_id=150;
						        	if (notch_MA==0)
						        		plot_title_2="-150 Hz";
						        	break;
						        case R.id.filter12_2:
						        	notch50or60=50;	
						        	notch_MA=1;
						        	plot_title_50_60=" ~ 50 Hz";
						        	plot_title_2="-25 Hz";
						        	break;	
						        case R.id.filter13_2:
						        	notch50or60=60;
						        	notch_MA=1;
						        	plot_title_50_60=" ~ 60 Hz";
						        	plot_title_2="-25 Hz";
						        	break;	
						        case R.id.filter14_2:
						        	notch50or60=50;	
						        	notch_MA=0;
						        	plot_title_50_60=" ~ 50 Hz";				        							        	
						        	break;						        	
						        case R.id.filter15_2:
						        	notch50or60=60;
						        	notch_MA=0;
						        	plot_title_50_60=" ~ 60 Hz";	
						        	break;						        	
						        case R.id.filter16_2:
						        	notch50or60=0;
						        	notch_MA=0;	
						        	plot_title_50_60="";	
						        	low_pass_filter_id=0;
						        	plot_title_2="-150 Hz"; 
						        	break;
						        	
					        	
						        default:						        	
						        	high_pass_filter_id=0;
						        	low_pass_filter_id=0;
						        	wandering_id=0;
						        	notch50or60=0;	
						        	plot_title_1="No digital filter / ECG - band: 0.1";  
						        	plot_title_2="-150 Hz"; 							
						        	plot_title_3="";
						        	plot_title_50_60="";
						        	notch_MA=0;
						        	break;
							  }
							  
	
							 
							 switch (low_pass_filter_id) {
			            
								case 25: // 25 Hz
							   			  
							   			filter_lB1[0]=B1_low25[0];
							   			filter_lB1[1]=B1_low25[1];
							   			filter_lB1[2]=B1_low25[2];
				
								    	filter_lA1[0]=A1_low25[0];
								    	filter_lA1[1]=A1_low25[1];
								    	filter_lA1[2]=A1_low25[2];
				
										filter_lB2[0]=B2_low25[0];
							   			filter_lB2[1]=B2_low25[1];
							   			filter_lB2[2]=B2_low25[2];
				
								    	filter_lA2[0]=A2_low25[0];
								    	filter_lA2[1]=A2_low25[1];
								    	filter_lA2[2]=A2_low25[2];
								    	
								    	G1_low=G1_low25;
								    	G2_low=G2_low25;
							   		 break;
					   		 
							   		 
						   		 case 35:  // 35 Hz
						   			  
						   			filter_lB1[0]=B1_low35[0];
						   			filter_lB1[1]=B1_low35[1];
						   			filter_lB1[2]=B1_low35[2];
				
							    	filter_lA1[0]=A1_low35[0];
							    	filter_lA1[1]=A1_low35[1];
							    	filter_lA1[2]=A1_low35[2];
				
									filter_lB2[0]=B2_low35[0];
						   			filter_lB2[1]=B2_low35[1];
						   			filter_lB2[2]=B2_low35[2];
				
							    	filter_lA2[0]=A2_low35[0];
							    	filter_lA2[1]=A2_low35[1];
							    	filter_lA2[2]=A2_low35[2];
							    	
							    	G1_low=G1_low35;
							    	G2_low=G2_low35;
						   		 break;
						   		 
						   		 
						   		 case 40:  // 40 Hz
						   			 
						   			filter_lB1[0]=B1_low40[0];
						   			filter_lB1[1]=B1_low40[1];
						   			filter_lB1[2]=B1_low40[2];
				
							    	filter_lA1[0]=A1_low40[0];
							    	filter_lA1[1]=A1_low40[1];
							    	filter_lA1[2]=A1_low40[2];
				
									filter_lB2[0]=B2_low40[0];
						   			filter_lB2[1]=B2_low40[1];
						   			filter_lB2[2]=B2_low40[2];
				
							    	filter_lA2[0]=A2_low40[0];
							    	filter_lA2[1]=A2_low40[1];
							    	filter_lA2[2]=A2_low40[2];
							    	
							    	G1_low=G1_low40;
							    	G2_low=G2_low40;
						   			break;
						   			
						   			
						   		case 100:  // 100 Hz
						   			
						   			filter_lB1[0]=B1_low100[0];
						   			filter_lB1[1]=B1_low100[1];
						   			filter_lB1[2]=B1_low100[2];
				
							    	filter_lA1[0]=A1_low100[0];
							    	filter_lA1[1]=A1_low100[1];
							    	filter_lA1[2]=A1_low100[2];
				
									filter_lB2[0]=B2_low100[0];
						   			filter_lB2[1]=B2_low100[1];
						   			filter_lB2[2]=B2_low100[2];
				
							    	filter_lA2[0]=A2_low100[0];
							    	filter_lA2[1]=A2_low100[1];
							    	filter_lA2[2]=A2_low100[2];
							    	
							    	G1_low=G1_low100;
							    	G2_low=G2_low100;
						   			break;
						   			
						   			
						   		case 150:  // 150 Hz
						   			
						   			filter_lB1[0]=B1_low150[0];
						   			filter_lB1[1]=B1_low150[1];
						   			filter_lB1[2]=B1_low150[2];
				
							    	filter_lA1[0]=A1_low150[0];
							    	filter_lA1[1]=A1_low150[1];
							    	filter_lA1[2]=A1_low150[2];
				
									filter_lB2[0]=B2_low150[0];
						   			filter_lB2[1]=B2_low150[1];
						   			filter_lB2[2]=B2_low150[2];
				
							    	filter_lA2[0]=A2_low150[0];
							    	filter_lA2[1]=A2_low150[1];
							    	filter_lA2[2]=A2_low150[2];
							    	
							    	G1_low=G1_low150;
							    	G2_low=G2_low150;
						   			break;
						   			
						   			
						   		default:  // 150 Hz
						   			
						   			filter_lB1[0]=B1_low150[0];
						   			filter_lB1[1]=B1_low150[1];
						   			filter_lB1[2]=B1_low150[2];
				
							    	filter_lA1[0]=A1_low150[0];
							    	filter_lA1[1]=A1_low150[1];
							    	filter_lA1[2]=A1_low150[2];
				
									filter_lB2[0]=B2_low150[0];
						   			filter_lB2[1]=B2_low150[1];
						   			filter_lB2[2]=B2_low150[2];
				
							    	filter_lA2[0]=A2_low150[0];
							    	filter_lA2[1]=A2_low150[1];
							    	filter_lA2[2]=A2_low150[2];
							    	
							    	G1_low=G1_low150;
							    	G2_low=G2_low150;
						   					   			
							 }
		   			
		           
							 switch (high_pass_filter_id) {
		            		           		            
					            case 1010: // 0.1 Hz
							    	
						   			filter_hB1[0]=B1_high1010[0];
						   			filter_hB1[1]=B1_high1010[1];
						   			filter_hB1[2]=B1_high1010[2];
			
							    	filter_hA1[0]=A1_high1010[0];
							    	filter_hA1[1]=A1_high1010[1];
							    	filter_hA1[2]=A1_high1010[2];
			
									filter_hB2[0]=B2_high1010[0];
						   			filter_hB2[1]=B2_high1010[1];
						   			filter_hB2[2]=B2_high1010[2];
			
							    	filter_hA2[0]=A2_high1010[0];
							    	filter_hA2[1]=A2_high1010[1];
							    	filter_hA2[2]=A2_high1010[2];
							    	
							    	G1_high=G1_high1010;
							    	G2_high=G2_high1010;
						            break;
						            
						            
					            case 1015: // 0.15 Hz
							    	
						   			filter_hB1[0]=B1_high1015[0];
						   			filter_hB1[1]=B1_high1015[1];
						   			filter_hB1[2]=B1_high1015[2];
			
							    	filter_hA1[0]=A1_high1015[0];
							    	filter_hA1[1]=A1_high1015[1];
							    	filter_hA1[2]=A1_high1015[2];
			
									filter_hB2[0]=B2_high1015[0];
						   			filter_hB2[1]=B2_high1015[1];
						   			filter_hB2[2]=B2_high1015[2];
			
							    	filter_hA2[0]=A2_high1015[0];
							    	filter_hA2[1]=A2_high1015[1];
							    	filter_hA2[2]=A2_high1015[2];
							    	
							    	G1_high=G1_high1015;
							    	G2_high=G2_high1015;
						            break;
					            
						            
					            case 1025: // 0.25 Hz
							    	
						   			filter_hB1[0]=B1_high1025[0];
						   			filter_hB1[1]=B1_high1025[1];
						   			filter_hB1[2]=B1_high1025[2];
			
							    	filter_hA1[0]=A1_high1025[0];
							    	filter_hA1[1]=A1_high1025[1];
							    	filter_hA1[2]=A1_high1025[2];
			
									filter_hB2[0]=B2_high1025[0];
						   			filter_hB2[1]=B2_high1025[1];
						   			filter_hB2[2]=B2_high1025[2];
			
							    	filter_hA2[0]=A2_high1025[0];
							    	filter_hA2[1]=A2_high1025[1];
							    	filter_hA2[2]=A2_high1025[2];
							    	
							    	G1_high=G1_high1025;
							    	G2_high=G2_high1025;
						            break;
						            
						            
					            case 1050: // 0.5 Hz
							    	
						   			filter_hB1[0]=B1_high1050[0];
						   			filter_hB1[1]=B1_high1050[1];
						   			filter_hB1[2]=B1_high1050[2];
			
							    	filter_hA1[0]=A1_high1050[0];
							    	filter_hA1[1]=A1_high1050[1];
							    	filter_hA1[2]=A1_high1050[2];
			
									filter_hB2[0]=B2_high1050[0];
						   			filter_hB2[1]=B2_high1050[1];
						   			filter_hB2[2]=B2_high1050[2];
			
							    	filter_hA2[0]=A2_high1050[0];
							    	filter_hA2[1]=A2_high1050[1];
							    	filter_hA2[2]=A2_high1050[2];
							    	
							    	G1_high=G1_high1050;
							    	G2_high=G2_high1050;
						            break;
						            
						            
						   		 case 1100: // 1 Hz
						    	
						   			filter_hB1[0]=B1_high1100[0];
						   			filter_hB1[1]=B1_high1100[1];
						   			filter_hB1[2]=B1_high1100[2];
			
							    	filter_hA1[0]=A1_high1100[0];
							    	filter_hA1[1]=A1_high1100[1];
							    	filter_hA1[2]=A1_high1100[2];
			
									filter_hB2[0]=B2_high1100[0];
						   			filter_hB2[1]=B2_high1100[1];
						   			filter_hB2[2]=B2_high1100[2];
			
							    	filter_hA2[0]=A2_high1100[0];
							    	filter_hA2[1]=A2_high1100[1];
							    	filter_hA2[2]=A2_high1100[2];
							    	
							    	G1_high=G1_high1100;
							    	G2_high=G2_high1100;	
					            break;
						   		  					                     
					            
					            default:  // 0.1 HZ
					            	
					            	filter_hB1[0]=B1_high1100[0];
						   			filter_hB1[1]=B1_high1100[1];
						   			filter_hB1[2]=B1_high1100[2];
			
							    	filter_hA1[0]=A1_high1100[0];
							    	filter_hA1[1]=A1_high1100[1];
							    	filter_hA1[2]=A1_high1100[2];
			
									filter_hB2[0]=B2_high1100[0];
						   			filter_hB2[1]=B2_high1100[1];
						   			filter_hB2[2]=B2_high1100[2];
			
							    	filter_hA2[0]=A2_high1100[0];
							    	filter_hA2[1]=A2_high1100[1];
							    	filter_hA2[2]=A2_high1100[2];
							    	
							    	G1_high=G1_high1100;
							    	G2_high=G2_high1100;
					            	
							 }
			    	
	    	
							 xSeries.clear();
    	  
							 filtering_function();	
	    		     							 	
							 dataset.clear();
							 mRenderer.setChartTitle(plot_title_0+plot_title_1+plot_title_2+plot_title_3+plot_title_50_60);
			    			 dataset.addSeries(0,xSeries);
			    			 point_12.clear();
				        	 edit_1.setText("");		
				        	 done_1=0;
						     done_2=0;
				        	 dataset.addSeries(1,point_12);
			    			 mChart.repaint();	        	     		        	     
			    		 	     	
			    			 return true;  
						 }  
						 });  
						 
						 popup.show();//showing popup menu
	
					}});	
			 
			 
			 
			 double size = file.length()/19;
			 int length_signal = (int) size;
			 
			 if (length_signal>18000) // ecg file length > seconds
				 Toast.makeText(getApplication(),"File dimension high! The App may slow down!", Toast.LENGTH_LONG).show();
	 
			 vector= new double[length_signal];			 
			 String NAME = file_name;
			 
			 
			 try { 
							 
				 vector = readFromFile(length_signal, NAME);			
				 vector_low_high_pass_filtered= new double[vector.length]; 	 
				 n_PQ=Math.round(vector.length/40);   // considero 40 bpm per stare larghi
				 PQ= new double[n_PQ];
				 PQ_x= new int[n_PQ];
				 PQ_interp= new double[vector.length];				 
				 double sum_vector = 0;
				 
				 for (int i = 0; i < vector.length; i++) 
				 {
					 sum_vector += vector[i];
				 }
					    
				 double mean_vector = sum_vector / vector.length;
				 
				 for(int i=0;i<vector.length;i++)
				     {
				      vector[i]=vector[i]-mean_vector;			     
				     }
				   								 
				 XYSeriesRenderer Xrenderer=new XYSeriesRenderer();
		         Xrenderer.setColor(Color.BLUE);
		         Xrenderer.setDisplayChartValues(false);
		         Xrenderer.setLineWidth(size_LineWidth); 
		         XYSeriesRenderer point_renderer=new XYSeriesRenderer();
		         point_renderer.setColor(Color.RED);
		         point_renderer.setPointStyle(PointStyle.CIRCLE);
		         point_renderer.setFillPoints(true);
		         point_renderer.setLineWidth(size_LineWidth*2);
		         mRenderer.setMarginsColor(Color.WHITE);
		         mRenderer.setXLabelsColor(Color.BLACK); 
		         mRenderer.setYLabelsColor(0,Color.BLACK); 
		         mRenderer.setLabelsColor(Color.BLACK);
		         mRenderer.setChartTitle(plot_title_0+plot_title_1+plot_title_2+plot_title_3+plot_title_50_60);
		         mRenderer.setXTitle("time [s] ");
		         mRenderer.setYTitle("mV");
		         mRenderer.setZoomButtonsVisible(true);
		         mRenderer.setXLabels(0);
		         mRenderer.setYLabels(0);
		         mRenderer.setPanEnabled(true);
		         mRenderer.setZoomEnabled(true, true);	        
		         mRenderer.setClickEnabled(false);
		         mRenderer.addSeriesRenderer(0, Xrenderer);
		         mRenderer.addSeriesRenderer(1, point_renderer);
		         mRenderer.setShowLegend(false);
		         mRenderer.setGridColor(Color.BLACK);
		         mRenderer.setYLabelsAngle(270);	         
		         mRenderer.setLabelsTextSize(size_LabelsTextSize);
		         mRenderer.setAxisTitleTextSize(size_AxisTitleTextSize);
		         mRenderer.setChartTitleTextSize(size_ChartTitleTextSize);
	      
		         
		         // Low pass filtering 40 Hz (as default)
		         
			   			filter_lB1[0]=B1_low40[0];
			   			filter_lB1[1]=B1_low40[1];
			   			filter_lB1[2]=B1_low40[2];
	
				    	filter_lA1[0]=A1_low40[0];
				    	filter_lA1[1]=A1_low40[1];
				    	filter_lA1[2]=A1_low40[2];
	
						filter_lB2[0]=B2_low40[0];
			   			filter_lB2[1]=B2_low40[1];
			   			filter_lB2[2]=B2_low40[2];
	
				    	filter_lA2[0]=A2_low40[0];
				    	filter_lA2[1]=A2_low40[1];
				    	filter_lA2[2]=A2_low40[2];
				    	
				    	G1_low=G1_low40;
				    	G2_low=G2_low40;
				    	
				    	
				// High pass filtering 0.1 Hz (as default)
				    	
				    	filter_hB1[0]=B1_high1010[0];
			   			filter_hB1[1]=B1_high1010[1];
			   			filter_hB1[2]=B1_high1010[2];
	
				    	filter_hA1[0]=A1_high1010[0];
				    	filter_hA1[1]=A1_high1010[1];
				    	filter_hA1[2]=A1_high1010[2];
	
						filter_hB2[0]=B2_high1010[0];
			   			filter_hB2[1]=B2_high1010[1];
			   			filter_hB2[2]=B2_high1010[2];
	
				    	filter_hA2[0]=A2_high1010[0];
				    	filter_hA2[1]=A2_high1010[1];
				    	filter_hA2[2]=A2_high1010[2];
				    	
				    	G1_high=G1_high1010;
				    	G2_high=G2_high1010;
	
				    	
		         filtering_function();
		         
		         dataset.addSeries(0, xSeries);
		         dataset.addSeries(1, point_12);
				 mChart=(GraphicalView)ChartFactory.getLineChartView(getBaseContext(), dataset, mRenderer);   			
				 layout_graph.addView(mChart);
			 
			  	 mRenderer.setXAxisMin(1);
			  	 mRenderer.setXAxisMax(8*Fs);
		 	  
			     double axis_y_delta=(20/(width/height))/2; 
			     mRenderer.setYAxisMin(-(axis_y_delta)*0.2);
			     mRenderer.setYAxisMax((axis_y_delta)*0.2);
			  	    
			    
			     mChart.addPanListener(new PanListener() {
		                @Override
		                public void panApplied() {		                   
		                	 plot_grid_function();	
		                }
			     });
	
				 				 
	    	     mChart.addZoomListener(new ZoomListener() {
	    	    	  public void zoomApplied(ZoomEvent e) {
	    	    		  plot_grid_function();
	    	    	  }
	
	    	    	  public void zoomReset() {
	    	    	  }
	    	     }, true, true);
	    	     

			 }  catch (Exception e) {}
			 	
			 
	}   // end on Create
	
	
	
	private double[] readFromFile(int length_signal, String nameFILE) {

			double [] ret= new double[length_signal];
		    int indice = 0;
	
		    try { 		    	 
		    		File file_dir = Environment.getExternalStorageDirectory();
		    		File f = new File(file_dir.getAbsolutePath() + "/" + files_folder,nameFILE);		    	
		    		InputStream inputStream = new FileInputStream(f);
		       	  
		    		if ( inputStream != null ) {
		            InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
		            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
		            String receiveString = "";
		            StringBuilder stringBuilder = new StringBuilder();
		           		            
		            while ( (receiveString = bufferedReader.readLine()) != null ) {
		            		ret[indice]=Double.parseDouble(receiveString);
		            		indice=indice +1 ;
		            }
	
		            inputStream.close();
		     
		    		}
		    }
		    catch (Exception e) {}
	
		    return ret;
	}
	
	
	void plot_grid_function()
	{
		
		double starty = mRenderer.getYAxisMin();
 	    double stopy = mRenderer.getYAxisMax();	         
 	    double startx = mRenderer.getXAxisMin();
 	    double stopx = mRenderer.getXAxisMax();
 	    double layout_width=layout_graph.getWidth();
 	    double layout_height=layout_graph.getHeight();
 	    double display_ratio=layout_width/layout_height;  	    
 	    double centreY=((stopy-starty)/2)+starty;
 	    double centreX=((stopx-startx)/2)+startx;
 	 	 
 	    if(((stopy-starty)*0.5/(0.2))<((stopx-startx)/Fs)) 	    	
 	    {
 	    	double x_lenght=((stopx - startx)/(0.2*Fs))/display_ratio; 	    
 	    	double y_lenght_mV=x_lenght*0.5; 	    	
 	    	mRenderer.setYAxisMin(centreY-(y_lenght_mV/2));
 	    	mRenderer.setYAxisMax(centreY+(y_lenght_mV/2));
 	    }   
 	    else
 	    {	    	     
 	  	    double y_lenght_mV=((stopy - starty)/(0.5))/(1/display_ratio); 
 	  	    double x_lenght=y_lenght_mV*0.2*Fs;		
 	  	    mRenderer.setXAxisMin(centreX-(x_lenght/2));
 	  	    mRenderer.setXAxisMax(centreX+(x_lenght/2));
 	    }
 	     	    
 	   mRenderer.clearXTextLabels();
 	   mRenderer.clearYTextLabels();
	   
 	   if ((stopx - startx)<(5*Fs))
 	   {   	    		         		   
    	    for (double i = startx; i <= stopx; i += 0.2*Fs) {
    	    	mRenderer.addXTextLabel(i+0.0015*Fs, String.format("%.2f", i/Fs) );
    	    }
    	 
    	    for (double i = startx; i <= stopx; i += 0.2*Fs) {
    	    	mRenderer.addXTextLabel(i+0.003*Fs, "" );
    	    }
    	 
    	    for (double i = startx; i <= stopx; i += 0.2*Fs) {
    	    	mRenderer.addXTextLabel(i+0.0045*Fs, "" );
    	    }
    	    
    	    for (double i = startx; i <= stopx; i += 0.04*Fs) {
    	    	mRenderer.addXTextLabel(i, "" );
    	    }
    	       	 
    	    for (double i = 0; i <= stopy; i += 0.5) {  // 0.5 mV
    	    	mRenderer.addYTextLabel(i+0.003, String.format("%.1f", i) );
    	    }
  	 
    	    for (double i = 0; i <= stopy; i += 0.5) {
    	    	mRenderer.addYTextLabel(i+0.006, "" );
    	    }
  	    
    	    for (double i = 0; i <= stopy; i += 0.5) {
    	    	mRenderer.addYTextLabel(i+0.009, "" );
    	    }
  	 
    	    for (double i = 0; i <= stopy; i += 0.1) { // 0.1 mV
    	    	mRenderer.addYTextLabel(i, "" );
    	    }
  	      	 
    	    for (double i = 0; i >= starty; i -= 0.5) {   // 0.5 mV
    	    	mRenderer.addYTextLabel(i+0.003, String.format("%.1f", i) );
    	    }
   	 
    	    for (double i = 0; i >=starty; i -= 0.5) {
    	    	mRenderer.addYTextLabel(i+0.006, "" );
    	    }
   	
    	    for (double i = 0; i >=starty; i -= 0.5) {
    	    	mRenderer.addYTextLabel(i+0.009, "" );
 		    }
	 
    	    for (double i = 0; i > starty; i -= 0.1) { // 0.1 mV
    	    	mRenderer.addYTextLabel(i, "" );
    	    }
   	 
    	    mRenderer.setShowCustomTextGrid(true); 
    	    
 	   }
	}
	
	
	
	void filtering_function()
	{
		
		for(int i=0;i<3;i++)
	    {
		buffer_fhB1[i]=0; 
		buffer_flB1[i]=0;
		buffer_fhA1[i]=0;
		buffer_flA1[i]=0;
		
		buffer_fhB2[i]=0;
		buffer_flB2[i]=0;
		buffer_fhA2[i]=0;
		buffer_flA2[i]=0;
		
		output_low1=0;
		output_low2=0;
		output_high1=0;
		output_high2=0;		
	    }
		
		 for(int i=0;i<vector.length;i++)
	     {		      
	            if (notch50or60==50)
	        	{				          	            	
	            	if (notch_MA==1)
    				{
	            		// Moving average filter with zeros at 50 , 100 , 150 , ... Hz (it is a notch filter + low pass filter at about 35 Hz
	            			            		
	            		buffer0_50[11]=buffer0_50[10];
	            		buffer0_50[10]=buffer0_50[9];
	            		buffer0_50[9]=buffer0_50[8];
	            		buffer0_50[8]=buffer0_50[7];
	            		buffer0_50[7]=buffer0_50[6];
	            		buffer0_50[6]=buffer0_50[5];
	            		buffer0_50[5]=buffer0_50[4];
		            	buffer0_50[4]=buffer0_50[3];
		            	buffer0_50[3]=buffer0_50[2];
						buffer0_50[2]=buffer0_50[1];
				        buffer0_50[1]=buffer0_50[0];
				        buffer0_50[0]=vector[i];         				    					  				          
				        output4_50_60=((buffer0_50[0]+buffer0_50[1]+buffer0_50[2]+buffer0_50[3]+buffer0_50[4]+buffer0_50[5]+buffer0_50[6]+buffer0_50[7]+buffer0_50[8]+buffer0_50[9]+buffer0_50[10]+buffer0_50[11])/12);				     
    				}
    				else
    				{
    					// Notch recursive filter at 50 Hz is applied twice
				         
				          buffer_num_filter_50[2]=buffer_num_filter_50[1];
				          buffer_num_filter_50[1]=buffer_num_filter_50[0];
				          buffer_num_filter_50[0]=vector[i];         
				          buffer_den_filter_50[2]=buffer_den_filter_50[1];
				          buffer_den_filter_50[1]=output1_50_60;					  
				          output1_50_60=G_filter_50*(buffer_num_filter_50[0]*num_filter_50[0]+buffer_num_filter_50[1]*num_filter_50[1]+buffer_num_filter_50[2]*num_filter_50[2])-buffer_den_filter_50[1]*den_filter_50[1]-buffer_den_filter_50[2]*den_filter_50[2];
				 		  
				          buffer2_num_filter_50[2]=buffer2_num_filter_50[1];
				          buffer2_num_filter_50[1]=buffer2_num_filter_50[0];
				          buffer2_num_filter_50[0]=output1_50_60;         
				          buffer2_den_filter_50[2]=buffer2_den_filter_50[1];
				          buffer2_den_filter_50[1]=output2_50_60;					  
				          output2_50_60=G_filter_50*(buffer2_num_filter_50[0]*num_filter_50[0]+buffer2_num_filter_50[1]*num_filter_50[1]+buffer2_num_filter_50[2]*num_filter_50[2])-buffer2_den_filter_50[1]*den_filter_50[1]-buffer2_den_filter_50[2]*den_filter_50[2];
				 		   		          
				       // Notch recursive filter at 100 Hz is applied twice  
				          
				          buffer_num_filter_100[2]=buffer_num_filter_100[1];
				          buffer_num_filter_100[1]=buffer_num_filter_100[0];
				          buffer_num_filter_100[0]=output2_50_60;         
				          buffer_den_filter_100[2]=buffer_den_filter_100[1];
				          buffer_den_filter_100[1]=output3_50_60;					  
				          output3_50_60=G_filter_100*(buffer_num_filter_100[0]*num_filter_100[0]+buffer_num_filter_100[1]*num_filter_100[1]+buffer_num_filter_100[2]*num_filter_100[2])-buffer_den_filter_100[1]*den_filter_100[1]-buffer_den_filter_100[2]*den_filter_100[2];				 		 
					
				          buffer2_num_filter_100[2]=buffer2_num_filter_100[1];
				          buffer2_num_filter_100[1]=buffer2_num_filter_100[0];
				          buffer2_num_filter_100[0]=output3_50_60;         
				          buffer2_den_filter_100[2]=buffer2_den_filter_100[1];
				          buffer2_den_filter_100[1]=output4_50_60;					  
				          output4_50_60=G_filter_100*(buffer2_num_filter_100[0]*num_filter_100[0]+buffer2_num_filter_100[1]*num_filter_100[1]+buffer2_num_filter_100[2]*num_filter_100[2])-buffer2_den_filter_100[1]*den_filter_100[1]-buffer2_den_filter_100[2]*den_filter_100[2];				 		 
    				}
	                            
			    }
	        	else
	        		 if (notch50or60==60)
	        		 {		
	            	 
	        				if (notch_MA==1)
	        				{
	        					// Moving average filter with zeros at 60 , 120 , 180 , ... Hz (it is a notch filter + low pass filter at about 35 Hz
	    	            			        					
		        			  buffer0_60[9]=buffer0_60[8];
		        			  buffer0_60[8]=buffer0_60[7];
		        			  buffer0_60[7]=buffer0_60[6];
		        			  buffer0_60[6]=buffer0_60[5];
		        			  buffer0_60[5]=buffer0_60[4];
			        		  buffer0_60[4]=buffer0_60[3];
				              buffer0_60[3]=buffer0_60[2];
							  buffer0_60[2]=buffer0_60[1];
					          buffer0_60[1]=buffer0_60[0];
					          buffer0_60[0]=vector[i];         
					          output4_50_60=((buffer0_60[0]+buffer0_60[1]+buffer0_60[2]+buffer0_60[3]+buffer0_60[4]+buffer0_60[5]+buffer0_60[6]+buffer0_60[7]+buffer0_60[8]+buffer0_60[9])/10);
					        					
	        				}
	        				else
	        				{
	        					// Notch recursive filter at 60 Hz is applied twice
		        		      buffer_num_filter_60[2]=buffer_num_filter_60[1];
					          buffer_num_filter_60[1]=buffer_num_filter_60[0];
					          buffer_num_filter_60[0]=vector[i];         
					          buffer_den_filter_60[2]=buffer_den_filter_60[1];
					          buffer_den_filter_60[1]=output1_50_60;						  
					          output1_50_60=G_filter_60*(buffer_num_filter_60[0]*num_filter_60[0]+buffer_num_filter_60[1]*num_filter_60[1]+buffer_num_filter_60[2]*num_filter_60[2])-buffer_den_filter_60[1]*den_filter_60[1]-buffer_den_filter_60[2]*den_filter_60[2];
					 		  				          
					          buffer2_num_filter_60[2]=buffer2_num_filter_60[1];
					          buffer2_num_filter_60[1]=buffer2_num_filter_60[0];
					          buffer2_num_filter_60[0]=output1_50_60;         
					          buffer2_den_filter_60[2]=buffer2_den_filter_60[1];
					          buffer2_den_filter_60[1]=output2_50_60;						  
					          output2_50_60=G_filter_60*(buffer2_num_filter_60[0]*num_filter_60[0]+buffer2_num_filter_60[1]*num_filter_60[1]+buffer2_num_filter_60[2]*num_filter_60[2])-buffer2_den_filter_60[1]*den_filter_60[1]-buffer2_den_filter_60[2]*den_filter_60[2];
					 		   			
					          
					          // Notch recursive filter at 120 Hz is applied twice				          
					          buffer_num_filter_120[2]=buffer_num_filter_120[1];
					          buffer_num_filter_120[1]=buffer_num_filter_120[0];
					          buffer_num_filter_120[0]=output2_50_60;         
					          buffer_den_filter_120[2]=buffer_den_filter_120[1];
					          buffer_den_filter_120[1]=output3_50_60;						  
					          output3_50_60=G_filter_120*(buffer_num_filter_120[0]*num_filter_120[0]+buffer_num_filter_120[1]*num_filter_120[1]+buffer_num_filter_120[2]*num_filter_120[2])-buffer_den_filter_120[1]*den_filter_120[1]-buffer_den_filter_120[2]*den_filter_120[2];				 		 
						
					          buffer2_num_filter_120[2]=buffer2_num_filter_120[1];
					          buffer2_num_filter_120[1]=buffer2_num_filter_120[0];
					          buffer2_num_filter_120[0]=output3_50_60;         
					          buffer2_den_filter_120[2]=buffer2_den_filter_120[1];
					          buffer2_den_filter_120[1]=output4_50_60;						  
					          output4_50_60=G_filter_120*(buffer2_num_filter_120[0]*num_filter_120[0]+buffer2_num_filter_120[1]*num_filter_120[1]+buffer2_num_filter_120[2]*num_filter_120[2])-buffer2_den_filter_120[1]*den_filter_120[1]-buffer2_den_filter_120[2]*den_filter_120[2];				 		 
	        				}
	        		 }
	        		 else
	        		  output4_50_60=vector[i];
			 
	
	            
	    	  //low pass filter
	            if (low_pass_filter_id!=0)
	        	{		            		         
	              buffer_flB1[2]=buffer_flB1[1];
		          buffer_flB1[1]=buffer_flB1[0];
		          buffer_flB1[0]=output4_50_60;       
		          buffer_flA1[2]=buffer_flA1[1];
		          buffer_flA1[1]=output_low1;				  
		          output_low1=G1_low*(buffer_flB1[0]*filter_lB1[0]+buffer_flB1[1]*filter_lB1[1]+buffer_flB1[2]*filter_lB1[2])-buffer_flA1[1]*filter_lA1[1]-buffer_flA1[2]*filter_lA1[2];
		 		          
		          buffer_flB2[2]=buffer_flB2[1];
		          buffer_flB2[1]=buffer_flB2[0];
		          buffer_flB2[0]=output_low1;         
		          buffer_flA2[2]=buffer_flA2[1];
		          buffer_flA2[1]=output_low2;				  
		          output_low2=G2_low*(buffer_flB2[0]*filter_lB2[0]+buffer_flB2[1]*filter_lB2[1]+buffer_flB2[2]*filter_lB2[2])-buffer_flA2[1]*filter_lA2[1]-buffer_flA2[2]*filter_lA2[2];				 		 			 		  		         
	        	}
	        	else
	        		output_low2=output4_50_60;
	            
	            
	          //high pass filter
	           if (high_pass_filter_id!=0)   
	           {		        			 		        		
	        	  buffer_fhB1[2]=buffer_fhB1[1];
                  buffer_fhB1[1]=buffer_fhB1[0];
                  buffer_fhB1[0]=output_low2;		                  
                  buffer_fhA1[2]=buffer_fhA1[1];
                  buffer_fhA1[1]=output_high1;        		  
                  output_high1=G1_high*(buffer_fhB1[0]*filter_hB1[0]+buffer_fhB1[1]*filter_hB1[1]+buffer_fhB1[2]*filter_hB1[2])-buffer_fhA1[1]*filter_hA1[1]-buffer_fhA1[2]*filter_hA1[2];
         		 		                  
                  buffer_fhB2[2]=buffer_fhB2[1];
                  buffer_fhB2[1]=buffer_fhB2[0];
                  buffer_fhB2[0]=output_high1;		                  
                  buffer_fhA2[2]=buffer_fhA2[1];
                  buffer_fhA2[1]=output_high2;       		  
                  output_high2=G2_high*(buffer_fhB2[0]*filter_hB2[0]+buffer_fhB2[1]*filter_hB2[1]+buffer_fhB2[2]*filter_hB2[2])-buffer_fhA2[1]*filter_hA2[1]-buffer_fhA2[2]*filter_hA2[2];      			         
	           }
	           else
	        	   output_high2=output_low2;
	        
	           
	           vector_low_high_pass_filtered[i]=output_high2;	            	            
	     }
	            
	            
	            
	     // filter to remove wandering line
	    	     
	    ind_PQ=0;	     
	 	if (wandering_id!=0)
	 	{ 		
	 		for(int i=0;i<vector_low_high_pass_filtered.length;i++)
	 		{      
	          	buffer_der1[4]=buffer_der1[3];
	       		buffer_der1[3]=buffer_der1[2];	
	       		buffer_der1[2]=buffer_der1[1];
	       		buffer_der1[1]=buffer_der1[0];
	       		buffer_der1[0]=vector_low_high_pass_filtered[i];	   
	       		output_der1=(buffer_der1[0]*der[0]+buffer_der1[1]*der[1]+buffer_der1[2]*der[2]+buffer_der1[3]*der[3]+buffer_der1[4]*der[4]);				 		 
		 	
	       		buffer_der2[4]=buffer_der2[3];
	       		buffer_der2[3]=buffer_der2[2];	
	       		buffer_der2[2]=buffer_der2[1];
	       		buffer_der2[1]=buffer_der2[0];
	       		buffer_der2[0]=output_der1;	    
	       		output_der2=(buffer_der2[0]*der[0]+buffer_der2[1]*der[1]+buffer_der2[2]*der[2]+buffer_der2[3]*der[3]+buffer_der2[4]*der[4]);				 		 
		 	          
	       		for (int y = 0; y < 199; y++) {
	       			buffer_wandering[199-y]=buffer_wandering[198-y];
	       		}	
	       		
	       		buffer_wandering[0]=output_der2;
	            
	       		if ((i>200) && (i<(vector_low_high_pass_filtered.length-200)) && (ind_PQ<n_PQ))     
	       		{            	
	       			summ=0;
		            for (int y = 0; y < 199; y++) {
		    			summ=summ+Math.abs(buffer_wandering[y]);
		    	    	}		            		            
		            threshold=summ*2*2/200;
		            
		            if ((-buffer_wandering[100]>threshold)  
		        		&& buffer_wandering[100]<buffer_wandering[90] && buffer_wandering[100]<buffer_wandering[91]  
	            		&& buffer_wandering[100]<buffer_wandering[92] && buffer_wandering[100]<buffer_wandering[93]
	            		&& buffer_wandering[100]<buffer_wandering[94] && buffer_wandering[100]<buffer_wandering[95]
	            		&& buffer_wandering[100]<buffer_wandering[96] && buffer_wandering[100]<buffer_wandering[97]
	            		&& buffer_wandering[100]<buffer_wandering[98] && buffer_wandering[100]<buffer_wandering[99]
	            		&& buffer_wandering[100]<buffer_wandering[101] && buffer_wandering[100]<buffer_wandering[102]
	            		&& buffer_wandering[100]<buffer_wandering[103] && buffer_wandering[100]<buffer_wandering[104]
	            		&& buffer_wandering[100]<buffer_wandering[105] && buffer_wandering[100]<buffer_wandering[106]
	            		&& buffer_wandering[100]<buffer_wandering[107] && buffer_wandering[100]<buffer_wandering[108]
	            		&& buffer_wandering[100]<buffer_wandering[109] && buffer_wandering[100]<buffer_wandering[110])		          
		            {		        	   		 		        	   
		        	  PQ[ind_PQ]=vector_low_high_pass_filtered[i-100];
		        	  PQ_x[ind_PQ]=i-100;
		        	  for (int z = 10; z < 45; z++)
		        	  {
		        		   if (PQ[ind_PQ]>vector_low_high_pass_filtered[i-100-z-1])
		    				{
		        			 PQ[ind_PQ]=vector_low_high_pass_filtered[i-100-z-1];
		        			 PQ_x[ind_PQ]=i-100-z-1;
		    				}
		        	   }
		        	  ind_PQ=ind_PQ+1;		 		        	   
		            }		            				 		           	 		            		                	
	       		}		            		                
	 		} 		        		 		        	
	 	   
	            	     
	 	// interp PQ to PQ_interp that has the same length of vector_low_pass_filtered
	 	
		 	for(int i=0;i<PQ_x[0];i++)
		    {
		 		PQ_interp[i]=0;
		    }
		 			 	
		 	for(int ind_PQ_x=1; ind_PQ_x<ind_PQ; ind_PQ_x++)
		 	{	
		 		for(int xi=PQ_x[ind_PQ_x-1]; xi<PQ_x[ind_PQ_x]; xi++)
			 	{	
			 		delta_interp_x=PQ_x[ind_PQ_x]-PQ_x[ind_PQ_x-1];
			 		delta_interp_y=PQ[ind_PQ_x]-PQ[ind_PQ_x-1];			 		
			 		PQ_interp[xi]=(delta_interp_y*(xi-PQ_x[ind_PQ_x-1])/delta_interp_x)+PQ[ind_PQ_x-1];
			 	}
		 	}
	 	
	 	}
	 	
	 	for(int i=0;i<vector_low_high_pass_filtered.length;i+=2)
	    {	 		 	    		    
		 	if (wandering_id!=0)
		 	 //  Adding data to the X Series.
	          xSeries.add(i,(vector_low_high_pass_filtered[i]-PQ_interp[i])*gain_x);
		 	else		        		
		 	 //  Adding data to the X Series.
	          xSeries.add(i,vector_low_high_pass_filtered[i]*gain_x);
	     }	
	}

}
